StringPool -

# class StringPool

- StringPool
- Reference
- Object

## Overview

A string pool is a collection of strings. It allows a runtime to save memory by preserving strings in a pool, allowing to reuse an instance of a common string instead of creating a new one.

    require "string_pool"

    pool = StringPool.new
    a = "foo" + "bar"
    b = "foo" + "bar"
    a.object_id # => 136294360
    b.object_id # => 136294336
    a = pool.get(a)
    b = pool.get(b)
    a.object_id # => 136294312
    b.object_id # => 136294312

## Defined in:

## Constructors

- .new(initial_capacity = 8)

  Creates a new empty string pool.

## Instance Method Summary

- #empty?

  Returns `true` if the `StringPool` has no element otherwise returns `false`.

- #get(str : Pointer(UInt8), len)

  Returns a `String` with the contents given by the pointer str of size len.

- #get(slice : Bytes)

  Returns a `String` with the contents of the given slice.

- #get(str : IO::Memory)

  Returns a `String` with the contents of the given `IO::Memory`.

- #get(str : String)

  Returns a `String` with the contents of the given string.

- #rehash

  Rebuilds the hash based on the current hash values for each key, if values of key objects have changed since they were inserted.

- #size : Int32

  Returns the size

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(initial_capacity = 8) #

Creates a new empty string pool.

The initial_capacity is useful to avoid unnecessary reallocations of the internal buffers in case of growth. If you have an estimate of the maximum number of elements the pool will hold it should be initialized with that capacity for improved performance.

    pool = StringPool.new(256)
    pool.size # => 0

## Instance Method Detail

def empty? #

Returns `true` if the `StringPool` has no element otherwise returns `false`.

    require "string_pool"

    pool = StringPool.new
    pool.empty? # => true
    pool.get("crystal")
    pool.empty? # => false

def get(str : Pointer(UInt8), len) #

Returns a `String` with the contents given by the pointer str of size len.

If a string with those contents was already present in the pool, that one is returned. Otherwise a new string is created, put in the pool and returned.

    require "string_pool"

    pool = StringPool.new
    pool.get("hey".to_unsafe, 3)
    pool.size # => 1

def get(slice : Bytes) #

Returns a `String` with the contents of the given slice.

If a string with those contents was already present in the pool, that one is returned. Otherwise a new string is created, put in the pool and returned.

    require "string_pool"

    pool = StringPool.new
    ptr = Pointer.malloc(9) { |i| ('a'.ord + i).to_u8 }
    slice = Slice.new(ptr, 3)
    pool.empty? # => true
    pool.get(slice)
    pool.empty? # => false
     ```

def get(str : IO::Memory) #

Returns a `String` with the contents of the given `IO::Memory`.

If a string with those contents was already present in the pool, that one is returned. Otherwise a new string is created, put in the pool and returned.

    require "string_pool"

    pool = StringPool.new
    io = IO::Memory.new "crystal"
    pool.empty? # => true
    pool.get(io)
    pool.empty? # => false

def get(str : String) #

Returns a `String` with the contents of the given string.

If a string with those contents was already present in the pool, that one is returned. Otherwise a new string is created, put in the pool and returned.

    require "string_pool"

    pool = StringPool.new
    string = "crystal"
    pool.empty? # => true
    pool.get(string)
    pool.empty? # => false

def rehash #

Rebuilds the hash based on the current hash values for each key, if values of key objects have changed since they were inserted.

Call this method if you modified a string submitted to the pool.

def size : Int32 #

Returns the size

    require "string_pool"

    pool = StringPool.new
    pool.size # => 0